#ifndef STRUCTS_H
#define	STRUCTS_H

#include <stdint.h>
#include "common.h"

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>

#define BUS_SPEED                       248625000
#define SECS_TO_TICKS(sec) (((unsigned long long)(sec)) * (BUS_SPEED/4))

typedef struct _private_data_t {
    EXPORT_DECL(void *, MEMAllocFromDefaultHeapEx,int size, int align);
    EXPORT_DECL(void, MEMFreeToDefaultHeap,void *ptr);

    EXPORT_DECL(void*, memcpy, void *p1, const void *p2, unsigned int s);
    EXPORT_DECL(void*, memset, void *p1, int val, unsigned int s);

    EXPORT_DECL(unsigned int, OSEffectiveToPhysical, const void*);
    EXPORT_DECL(void, exit, int);
    EXPORT_DECL(void, DCInvalidateRange, const void *addr, unsigned int length);
    EXPORT_DECL(void, DCFlushRange, const void *addr, unsigned int length);
    EXPORT_DECL(void, ICInvalidateRange, const void *addr, unsigned int length);

    EXPORT_DECL(int, FSInit, void);
    EXPORT_DECL(int, FSAddClientEx, void *pClient, int unk_zero_param, int errHandling);
    EXPORT_DECL(int, FSDelClient, void *pClient);
    EXPORT_DECL(void, FSInitCmdBlock, void *pCmd);
    EXPORT_DECL(int, FSGetMountSource, void *pClient, void *pCmd, int type, void *source, int errHandling);
    EXPORT_DECL(int, FSMount, void *pClient, void *pCmd, void *source, const char *target, uint32_t bytes, int errHandling);
    EXPORT_DECL(int, FSUnmount, void *pClient, void *pCmd, const char *target, int errHandling);
    EXPORT_DECL(int, FSOpenFile, void *pClient, void *pCmd, const char *path, const char *mode, int *fd, int errHandling);
    EXPORT_DECL(int, FSGetStatFile, void *pClient, void *pCmd, int fd, void *buffer, int error);
    EXPORT_DECL(int, FSReadFile, void *pClient, void *pCmd, void *buffer, int size, int count, int fd, int flag, int errHandling);
    EXPORT_DECL(int, FSCloseFile, void *pClient, void *pCmd, int fd, int errHandling);

    EXPORT_DECL(unsigned int, OSScreenPutFontEx, unsigned int bufferNum, unsigned int posX, unsigned int posY, const char * buffer);

    EXPORT_DECL(void, OSScreenInit, void);
    EXPORT_DECL(void, OSForceFullRelaunch, void);
    EXPORT_DECL(unsigned int, OSScreenGetBufferSizeEx, unsigned int bufferNum);
    EXPORT_DECL(unsigned int, OSScreenSetBufferEx, unsigned int bufferNum, void * addr);
    EXPORT_DECL(unsigned int, OSScreenClearBufferEx, unsigned int bufferNum, unsigned int temp);
    EXPORT_DECL(unsigned int, OSScreenFlipBuffersEx, unsigned int bufferNum);
    EXPORT_DECL(unsigned int, OSSleepTicks, uint64_t ticks);

    EXPORT_DECL(int, SYSRelaunchTitle, int argc, char** argv);
    EXPORT_DECL(void, SYSLaunchMenu, void);
    EXPORT_DECL(void, _SYSLaunchMiiStudio, void);
    EXPORT_DECL(int, _SYSLaunchTitleWithStdArgsInNoSplash, unsigned long long tid, void *ptr);
    EXPORT_DECL(unsigned long long, _SYSGetSystemApplicationTitleId, int sysApp);
    uint64_t sysmenuTitleID;
} private_data_t;

#ifdef __cplusplus
}
#endif

#endif	/* STRUCTS_H */

